﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Data;
using System.Diagnostics;
using System.Data.SqlClient;
using MVC5Gantt.Models;
using System.Web.Configuration;

namespace MVC5Gantt.Controllers
{
    public class GanttData
    {
        public int TaskId { get; set; }
        public string TaskName { get; set; }
        public string StartDate { get; set; }
        public string EndDate { get; set; }
        public int Progress { get; set; }
        public int Duration { get; set; }
        public int Cost { get; set; }
        public int ParentId { get; set; }
        public string Predescessor { get; set; }

    }
    public class GanttController : Controller
    {
        //
        // GET: /Gantt/

        string connectionString;
        public ActionResult Index()
        {
            connectionString = string.Format(@"Data Source=(LocalDB)\v11.0;AttachDbFilename=" + Server.MapPath("App_Data") + @"\GanttDataSource.mdf;Integrated Security=True;Connect Timeout=30");
            SqlConnection conn = new SqlConnection(WebConfigurationManager.ConnectionStrings["DefaultConnection"].ConnectionString);

            conn.Open();

            SqlCommand comm = new SqlCommand("SELECT * FROM GanttData1", conn);
            SqlDataReader reader = comm.ExecuteReader();
            DataTable dt = new DataTable();
            dt.Load(reader);

            conn.Close();


            Data data = new Data();

            ParentTable = data.GetParentTableRows(dt);

            ViewBag.dataSource = ParentTable;
            return View();
        }
        //
        // GET: /Gantt
        List<TaskData> ParentTable;
        List<TaskData> ParentTable1;
        List<TaskData> ChildTable;

        [HttpPost()]
        public void Update(TaskData Task)
        {
            //Update Edited TaskDetails
            //Using UPDATE SQL Query to Save the Modified taskData into the Table

            connectionString = string.Format(@"Data Source=(LocalDB)\v11.0;AttachDbFilename=" + Server.MapPath("App_Data") + @"\GanttDataSource.mdf;Integrated Security=True;Connect Timeout=30");

            int IDNumber = Task.TaskId;

            string cmdString = "UPDATE GanttData1 SET TaskId=@TaskId, TaskName=@TaskName,StartDate=@StartDate,EndDate=@EndDate,Duration=@Duration,Progress=@Progress,ParentId=@ParentId,Predecessor=@Predecessor WHERE TaskId = '" + IDNumber + "'";

            SqlConnection con = new SqlConnection(WebConfigurationManager.ConnectionStrings["DefaultConnection"].ConnectionString);//connectionString

            con.Open();
            using (SqlCommand sqlCommand = new SqlCommand(cmdString, con))
            {
                sqlCommand.Parameters.AddWithValue("@TaskName", Task.TaskName);
                sqlCommand.Parameters.AddWithValue("@Duration", Task.Duration);
                sqlCommand.Parameters.AddWithValue("@StartDate", Task.StartDate);
                sqlCommand.Parameters.AddWithValue("@TaskId", Task.TaskId);
                sqlCommand.Parameters.AddWithValue("@EndDate", Task.EndDate);
                sqlCommand.Parameters.AddWithValue("@Progress", Task.Progress);

                if (Task.ParentId == null)
                {
                    sqlCommand.Parameters.AddWithValue("@ParentId", Task.ParentId).Value = "0";
                }
                else
                {
                    sqlCommand.Parameters.AddWithValue("@ParentId", Task.ParentId);
                }
                if (Task.Predecessor == null)
                {
                    sqlCommand.Parameters.AddWithValue("@Predecessor", Task.Predecessor).Value = "";
                }
                else
                {
                    sqlCommand.Parameters.AddWithValue("@Predecessor", Task.Predecessor);
                }

                sqlCommand.ExecuteNonQuery();
            }

            con.Close();
        }


        [HttpPost()]
        public void Add(TaskData Task)
        {

            //Here Task is the added New Task
            //Add Task 
            //Using INSERT Query to add the New Record to SQL Table

            string cmdString = "INSERT INTO GanttData1 ([TaskName],[TaskId],[StartDate],[EndDate],[Duration],[Progress],[ParentId],[Predecessor])" + "VALUES(@TaskName,@TaskId,@StartDate,@EndDate,@Duration,@Progress,@ParentId,@Predecessor)";

            connectionString = string.Format(@"Data Source=(LocalDB)\v11.0;AttachDbFilename=" + Server.MapPath("App_Data") + @"\GanttDataSource.mdf;Integrated Security=True;Connect Timeout=30");

            SqlConnection con = new SqlConnection(WebConfigurationManager.ConnectionStrings["DefaultConnection"].ConnectionString);//connectionString

            con.Open();
            using (SqlCommand sqlCommand = new SqlCommand(cmdString, con))
            {
                sqlCommand.Parameters.AddWithValue("@TaskName", Task.TaskName);
                sqlCommand.Parameters.AddWithValue("@Duration", Task.Duration);
                sqlCommand.Parameters.AddWithValue("@StartDate", Task.StartDate);
                sqlCommand.Parameters.AddWithValue("@TaskId", Task.TaskId);
                sqlCommand.Parameters.AddWithValue("@EndDate", Task.EndDate);
                sqlCommand.Parameters.AddWithValue("@Progress", Task.Progress);

                if (Task.ParentId == null)
                {
                    sqlCommand.Parameters.AddWithValue("@ParentId", Task.ParentId).Value = "0";
                }
                else
                {
                    sqlCommand.Parameters.AddWithValue("@ParentId", Task.ParentId);
                }
                if (Task.Predecessor == null)
                {
                    sqlCommand.Parameters.AddWithValue("@Predecessor", Task.Predecessor).Value = "";
                }
                else
                {
                    sqlCommand.Parameters.AddWithValue("@Predecessor", Task.Predecessor);
                }

                int test = sqlCommand.ExecuteNonQuery();
            }

            con.Close();

        }

        [HttpPost()]
        public void Delete(TaskData Task)
        {

            //Delete Task 
            //Using Delete Query to delete Record from SQL Table


            connectionString = string.Format(@"Data Source=(LocalDB)\v11.0;AttachDbFilename=" + Server.MapPath("App_Data") + @"\GanttDatabase2008.mdf;Integrated Security=True;Connect Timeout=30");

            int IDNumber = Task.TaskId;
            SqlConnection con = new SqlConnection(WebConfigurationManager.ConnectionStrings["DefaultConnection"].ConnectionString);//connectionString
            con.Open();
            SqlCommand cmd = new SqlCommand("delete from GanttData1 where TaskId = '" + IDNumber + "'", con);
            int result = cmd.ExecuteNonQuery();
            con.Close();

        }

    }
}
